"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  VitePluginVueDialog: () => VitePluginVueDialog,
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);

// src/parser/index.ts
var import_compiler_sfc = require("@vue/compiler-sfc");
var import_magic_string = __toESM(require("magic-string"));
var import_unimport = require("unimport");
var Parser = class {
  constructor(code) {
    this.code = code;
  }
  unimport;
  descriptor;
  autoAddImport;
  isImport;
  parseCode(code) {
    const { descriptor } = (0, import_compiler_sfc.parse)(code);
    this.descriptor = descriptor;
  }
  async createUnImport(declaration) {
    const unimport = (0, import_unimport.createUnimport)({
      imports: [{ name: "default", as: "$dialog", from: declaration + "/index" }]
    });
    this.unimport = unimport;
  }
  async isUnImport() {
    const re = await this.unimport.injectImports(this.code);
    this.isImport = re.imports.length > 0;
    this.autoAddImport = re.code;
  }
  importMoundle(code) {
    const s = new import_magic_string.default(code);
    const { source } = this.descriptor;
    s.replace(source, "");
    return s.toString();
  }
  transformer(code, importCode) {
    const s = new import_magic_string.default(code);
    const { scriptSetup } = this.descriptor;
    const translate = scriptSetup?.content ?? "";
    s.replace(translate, "\n" + importCode.toString() + translate);
    return s.toString();
  }
};

// src/parser/declaration.ts
var import_fs = require("fs");
var import_magic_string2 = __toESM(require("magic-string"));
var import_vite = require("vite");
var Declaration = class {
  constructor(dir) {
    this.dir = dir;
  }
  path;
  files;
  comps;
  create() {
    this.path = (0, import_vite.normalizePath)(process.cwd()) + this.dir;
    this.files = (0, import_fs.readdirSync)(this.path);
  }
  component(files) {
    this.comps = files.filter((f) => f.endsWith(".vue") && !f.startsWith("index")).map((s) => new import_magic_string2.default(s).replaceAll(".vue", "").toString().toLowerCase());
  }
  transform(comps) {
    const code = comps.map((v) => `function ${v}(fn):[{value:boolean} , typeof import('vue')['ref']] ;`);
    const s = new import_magic_string2.default(code.join("\n"));
    s.prepend("type fn = (params?:any)=> void \ndeclare namespace $dialog { \n").append("\n}");
    return s.toString();
  }
  visable(path) {
    if (!path.endsWith(".vue"))
      return false;
    const files = (0, import_fs.readdirSync)(this.path);
    if (files.length === this.files.length)
      return false;
    this.files = files;
    return true;
  }
  updatedts() {
    this.component(this.files);
    const s = this.transform(this.comps);
    this.wirtedts(s);
  }
  wirtedts(s) {
    import_fs.promises.writeFile(this.path + "/com.d.ts", s, "utf-8");
  }
};

// src/index.ts
var VitePluginVueDialog = (options = { dirs: "src/components" }) => {
  const opt = options ?? {};
  let parser;
  let declaration;
  declaration = new Declaration("/" + opt.dirs);
  return {
    name: "vite-pligin-vue-dialog",
    enforce: "pre",
    async configResolved(_conifg) {
      declaration.create();
      declaration.updatedts();
    },
    handleHotUpdate(ctx) {
      const visable = declaration.visable(ctx.file);
      if (visable)
        declaration.updatedts();
    },
    async transform(code, id) {
      if (/\.vue$/.test(id) || /\.vue\?.*type=script.*/.test(id)) {
        parser = new Parser(code);
        if (!parser.unimport)
          await parser.createUnImport(declaration.path);
        await parser.isUnImport();
        if (!parser.isImport) {
          return null;
        }
        parser.parseCode(code);
        const importCode = parser.importMoundle(parser.autoAddImport);
        const s = parser.transformer(code, importCode);
        return s;
      }
    }
  };
};
var src_default = VitePluginVueDialog;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  VitePluginVueDialog
});
